<?php defined("SYSPATH") or die("No direct script access.");
/**
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2009 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
class Admin_histogram_Block_Controller extends Admin_Controller {
  public function index() {
    print $this->_get_view();
  }

  public function handler() {
    access::verify_csrf();

    $form = $this->_get_form();
    if ($form->validate()) {
      module::set_var(
        "histogram", "title", $form->histogram->title->value);
      module::set_var(
        "histogram", "width", $form->histogram->width->value);
      module::set_var(
        "histogram", "height", $form->histogram->height->value);
      module::set_var(
        "histogram", "color", $form->histogram->color->value);
	  module::set_var(
        "histogram", "bgcolor", $form->histogram->bgcolor->value);
		
      message::success(t("Your settings have been saved."));  
      url::redirect("admin/histogram_block");
    }

    print $this->_get_view($form);
  }

  private function _get_view($form=null) {
    $v = new Admin_View("admin.html");
    $v->content = new View("admin_histogram_block.html");
    $v->content->form = empty($form) ? $this->_get_form() : $form;
    return $v;
  }

  private function _get_form() {
    $form = new Forge("admin/histogram_block/handler", "", "post", array("id" => "g-admin-form"));
    
	$group = $form->group("histogram")->label(t("Histogram visual settings."));
    $group->input("title")->label(t('Enter the title of the block.'))
		->value(module::get_var("histogram", "title"));
	$group->input("width")->label(t('Width of histogram image.  Recommend: 200.'))
		->rules('required|length[2,3]|valid_numeric')
		->value(module::get_var("histogram", "width"));
	$group->input("height")->label(t('Height of histogram image.  Recommend: 150.'))
		->rules('required|length[2,3]|valid_numeric')
		->value(module::get_var("histogram", "height"));
	$group->input("color")->label(t('Color of cart of histogram.'))
		->class("js_color {hash:false}")
		->value(module::get_var("histogram", "color"));
	$group->input("bgcolor")->label(t('Background color of histogram.'))
		->class("js_color {hash:false}")
		->value(module::get_var("histogram", "bgcolor"));
		
		
    $form->submit("submit")->value(t("Save"));
    return $form;
  }
}